import { jsx as t, jsxs as c } from "react/jsx-runtime";
import f, { defaultProps as y } from "prism-react-renderer";
import { createContext as k, useContext as v, useState as b } from "react";
import { useMediaQuery as x } from "react-responsive";
import D from "@guoyunhe/prism-theme-github/github-dark.css?used&raw";
import T from "@guoyunhe/prism-theme-github/github-light.css?used&raw";
import C from "react-use-localstorage";
const j = {
  cjs: "javascript",
  cts: "typescript",
  htm: "markup",
  html: "markup",
  js: "javascript",
  md: "markdown",
  mjs: "javascript",
  mts: "typescript",
  svg: "markup",
  ts: "typescript",
  xml: "markup",
  yml: "yaml"
};
function S(e) {
  return j[e] || e;
}
function B({ code: e, language: n, style: o }) {
  return /* @__PURE__ */ t(
    f,
    {
      ...y,
      theme: void 0,
      code: e.trim(),
      language: S(n),
      children: ({ className: i, style: r, tokens: a, getLineProps: l, getTokenProps: u }) => /* @__PURE__ */ t("pre", { className: i, style: { ...r, ...o }, children: a.map((d, m) => /* @__PURE__ */ t("div", { ...l({ line: d, key: m }), children: /* @__PURE__ */ t("span", { children: d.map((g, h) => /* @__PURE__ */ t("span", { ...u({ token: g, key: h }) }, h)) }) }, m)) })
    }
  );
}
function M({ maxWidth: e = 800, style: n = {}, ...o }) {
  return /* @__PURE__ */ t(
    "div",
    {
      ...o,
      style: { ...n, maxWidth: e, margin: "auto", paddingLeft: 20, paddingRight: 20 }
    }
  );
}
const p = k({
  theme: "auto",
  actualTheme: "light",
  systemTheme: "light",
  setTheme: () => null
});
function s() {
  return v(p);
}
function Q({ children: e }) {
  const { actualTheme: n } = s();
  return /* @__PURE__ */ t(
    "div",
    {
      style: {
        borderWidth: 1,
        borderStyle: "solid",
        borderColor: n === "dark" ? "#30363d" : "#d8dee4",
        borderRadius: 6,
        padding: 16,
        marginBottom: 16
      },
      children: e
    }
  );
}
function U({ title: e }) {
  const { theme: n, systemTheme: o, setTheme: i } = s();
  return /* @__PURE__ */ c("div", { style: { marginBottom: 16, display: "flex", alignItems: "center" }, children: [
    /* @__PURE__ */ t("h1", { style: { flex: "1 1 auto", margin: 0 }, children: e }),
    /* @__PURE__ */ c("div", { style: { textAlign: "right" }, children: [
      "Theme: ",
      /* @__PURE__ */ c(
        "select",
        {
          value: n,
          onChange: (r) => i(r.target.value),
          style: { border: 0, padding: 0, background: "transparent", color: "inherit" },
          children: [
            /* @__PURE__ */ c("option", { value: "auto", children: [
              o === "dark" ? "🌙" : "☀️",
              " Auto"
            ] }),
            /* @__PURE__ */ t("option", { value: "light", children: "☀️ Light" }),
            /* @__PURE__ */ t("option", { value: "dark", children: "🌙 Dark" })
          ]
        }
      )
    ] })
  ] });
}
function W({ level: e = 1, children: n, style: o, ...i }) {
  let r;
  switch (e) {
    case 2:
      r = "h3";
      break;
    case 3:
      r = "h4";
      break;
    case 4:
      r = "h5";
      break;
    case 5:
      r = "h6";
      break;
    default:
      r = "h2";
  }
  return /* @__PURE__ */ t(r, { ...i, style: { ...o }, children: n });
}
const z = `html {
  font-size: 14px;
}

body {
  margin: 0;
}

h1 {
  font-size: 36px;
  font-weight: 400;
}

h2 {
  font-size: 32px;
  font-weight: 400;
}

h3 {
  font-size: 28px;
  font-weight: 400;
}

ol,
ul {
  margin-left: 0;
  padding-left: 1em;
}
`, L = `body {
  margin: 0;
  background: #0d1117;
  color: #c9d1d9;
  font-size: 14px;
}
`, w = `body {
  margin: 0;
  background: #ffffff;
  color: #000000;
  font-size: 14px;
}
`;
function E({ children: e }) {
  const [n, o] = C("react-doc-ui-theme", "auto"), r = x({ query: "(prefers-color-scheme: dark)" }) ? "dark" : "light", a = n === "auto" ? r : n;
  return /* @__PURE__ */ c(p.Provider, { value: { theme: n, systemTheme: r, actualTheme: a, setTheme: o }, children: [
    /* @__PURE__ */ t("style", { children: z }),
    /* @__PURE__ */ t("style", { children: a === "light" ? w : L }),
    /* @__PURE__ */ t("style", { children: a === "light" ? T : D }),
    e
  ] });
}
function G({ files: e }) {
  const { actualTheme: n } = s(), [o, i] = b(0), r = n === "dark" ? "#161b22" : "#f6f8fa";
  return /* @__PURE__ */ c("div", { style: { marginBottom: 16 }, children: [
    /* @__PURE__ */ t("div", { style: { paddingLeft: 16, paddingRight: 16, display: "flex" }, children: e.map((a, l) => /* @__PURE__ */ t(
      "div",
      {
        onClick: () => {
          i(l);
        },
        style: {
          background: o === l ? r : "transparent",
          cursor: "pointer",
          padding: "4px 12px",
          borderRadius: "6px 6px 0 0"
        },
        children: a.filename || a.language.toUpperCase()
      },
      a.filename || l
    )) }),
    e.map((a, l) => /* @__PURE__ */ t(
      B,
      {
        ...a,
        style: { marginTop: 0, display: o === l ? "block" : "none" }
      },
      a.filename || l
    ))
  ] });
}
export {
  B as DocCodeBlock,
  M as DocContainer,
  p as DocContext,
  Q as DocDemoBlock,
  U as DocHeader,
  W as DocHeading,
  E as DocProvider,
  G as DocTabCodeBlock,
  s as useDoc
};
